unit replaceWin;

interface

uses
  Windows, Messages, SysUtils, Variants, Types, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, TextEditor;

type
  TreplaceFrm = class(TForm)
    cbMatchCase: TCheckBox;
    cbWWO: TCheckBox;
    btnReplaceAll: TButton;
    btnClose: TButton;
    cbLF: TCheckBox;
    rbSelection: TRadioButton;
    rbEntireFile: TRadioButton;
    stSearchFor: TStaticText;
    eSearch: TEdit;
    stReplaceWith: TStaticText;
    eReplace: TEdit;
    stScope: TStaticText;
    procedure CheckValidSettings(Sender: TObject);
    procedure btnReplaceAllClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  replaceFrm: TreplaceFrm;

implementation

uses mainWin;

{$R *.dfm}

procedure TreplaceFrm.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TreplaceFrm.btnReplaceAllClick(Sender: TObject);
var
  num: integer;
begin
  Screen.Cursor := crHourglass;
  try
    num := RejbrandTextEditor.Editor.ReplaceAll(
      MakeFindQuery(eSearch.Text,
        cbMatchCase.Checked,
        cbWWO.Checked,
        cbLF.Checked),
      eReplace.Text, rbSelection.Checked);
  finally
    Screen.Cursor := crDefault;
  end;
  if num = 0 then
    MessageBox(Handle,
      'The search text was not found; the file has not been changed.',
      PChar(Caption), MB_ICONINFORMATION or MB_OK)
  else
    MessageBox(Handle,
      PChar(IntToStr(num) + ' match(es) replaced.'),
      PChar(Caption), MB_ICONINFORMATION or MB_OK);
  FormActivate(Sender);
end;

procedure TreplaceFrm.CheckValidSettings(Sender: TObject);
begin
  btnReplaceAll.Enabled := not (rbSelection.Checked and (RejbrandTextEditor.Editor.SelectionType = stBlock) and cbLF.Checked);
end;

procedure TreplaceFrm.FormActivate(Sender: TObject);
begin
  rbSelection.Enabled := RejbrandTextEditor.Editor.TextFile.HasSelection;
  if not rbSelection.Enabled then
    rbEntireFile.Checked := true;
end;

end.
